<template>
  <div class="home">
    <router-link to="/report">
      <img id="logo" src="../assets/logo.svg" class="center" />
    </router-link>
    <div class="splash text-center">
      <h1>Welcome to {{ title }}</h1>
      <p>
        <strong>open c</strong>rowdsourced
        <strong>u</strong>ser-<strong>t</strong>esting <strong>s</strong>uite
        <nobr v-show="author"> by {{ author }}</nobr>
      </p>

      <b-button size="lg" variant="primary" to="/report">
        <b-icon-clipboard-data />
        Test something!
      </b-button>
    </div>

    <div class="dashboard">
      <h2>Systems <b-icon-file-earmark-text /></h2>
      <p>{{ systems.length }} systems can be tested with {{ title }}</p>
      <CreateSystem />
      <b-table
        :items="systems"
        :busy="this.$apollo.queries.systems.loading"
        :fields="[
          { key: 'name', label: 'System', sortable: true },
          { key: 'description', sortable: true }
        ]"
        sort-by="name"
        :sort-desc="true"
        class="mt-3"
        outlined
        striped
        hover
        selectable
        select-mode="single"
        @row-selected="systemSelected"
      >
        <template v-slot:cell(name)="data">
          <router-link :to="`/system/${data.item.id}`">{{
            data.item.name
          }}</router-link>
        </template>
        <template v-slot:table-busy>
          <Loading />
        </template>
      </b-table>

      <h2>Users <b-icon-people /></h2>
      <p>{{ users.length }} users are testing with {{ title }}</p>
      <b-table
        :items="users"
        :busy="this.$apollo.queries.users.loading"
        :fields="[
          { key: 'name', sortable: true },
          { key: 'joined', sortable: true },
          { key: 'activity', sortable: true }
        ]"
        sort-by="activity"
        :sort-desc="true"
        class="mt-3"
        outlined
        striped
        hover
        selectable
        select-mode="single"
        @row-selected="userSelected"
      >
        <template v-slot:cell(name)="data">
          <router-link :to="`/user/${data.item.id}`">{{
            data.item.name
          }}</router-link>
        </template>
        <template v-slot:cell(joined)="data">
          {{ new Date(Number(data.value)).toLocaleString() }}
        </template>
        <template v-slot:table-busy>
          <Loading />
        </template>
      </b-table>
    </div>
  </div>
</template>

<script>
import Loading from "@/components/Loading.vue";
import CreateSystem from "@/components/CRUDE/CreateSystem.vue";
import gql from "graphql-tag";

export default {
  name: "Home",
  data() {
    return {
      title: process.env.VUE_APP_TITLE || "OPEN-CUTS",
      author: process.env.VUE_APP_AUTHOR,
      systems: [],
      users: []
    };
  },
  components: {
    Loading,
    CreateSystem
  },
  apollo: {
    systems: {
      query: gql`
        query {
          systems {
            id
            name
            description
          }
        }
      `
    },
    users: {
      query: gql`
        query {
          users {
            id
            name
            joined
            activity
          }
        }
      `
    }
  },
  methods: {
    systemSelected(items) {
      this.$router.push({ path: `/system/${items[0].id}` });
    },
    userSelected(items) {
      this.$router.push({ path: `/user/${items[0].id}` });
    }
  }
};
</script>
